# Getting Started with Verilog

## Getting Ubuntu
You will need to install Ubuntu, since chip verification is easiest from Linux.
If you don't want to run Ubuntu natively, I highly recommend using [VMWare Player](https://www.vmware.com/products/workstation-player.html) as a virtualization system.

## Install Docker
Docker is a useful tool for CI/CD.
It will allow us to reproducibly build software across multiple environments.
Assuming you are on Ubuntu, follow [Docker's installation instructions](https://docs.docker.com/engine/install/ubuntu/).

# Installing Programming Tools
This section will detail how to install an open-source toolchain for the Alchitry Cu.
In the future, I will include notes on how to build for the alchitry Au.
Included in the repository is a Dockerfile which builds all these tools, which may prove easier than doing it yourself.

First, we need to install all dependencies that will be used in our system:
```
sudo apt install -y build-essential clang bison flex libreadline-dev \
    gawk tcl-dev libffi-dev git mercurial graphviz libeigen3-dev \
    xdot pkg-config python python3 libftdi-dev \
    qt5-default python3-dev libboost-all-dev cmake gtkwave git
 
```

## Synthesis Toolchain
All applications listed can either be installed from the apt universe *or* built from the source.
Installing from the apt universe is the best idea, but may not be possible on all systems.
Only execute one of the following two sections.
### Installing with apt (recommended)
Even though we are installing existing applications, we still need to build some components.

Next, we will install an easy-to-use, open-source simulator, called [Icarus Verilog](http://iverilog.icarus.com/).
This is done with:
```
sudo apt install iverilog gtkwave
```

Now we can install [Yosys](http://www.clifford.at/yosys/), which is an [open-source logic synthesis tool](https://en.wikipedia.org/wiki/Logic_synthesis).
```
sudo apt install yosys
```

### Building from Sources (not recommended)

Building iverilog from sources.
```
git clone git://github.com/steveicarus/iverilog.git iverilog
sudo apt-get install autoconf bison flex gperf libreadline6 \
    libreadline6-dev libncurses5-dev
(
        cd iverilog
        bash autoconf.sh
        ./configure
        make -j$(nproc)
        sudo make install
)
```

Yosys:
```
# Install yosys synthesis tool
git clone https://github.com/cliffordwolf/yosys.git yosys
(
	cd yosys
	make -j$(nproc)
	sudo make install
)
```

## Bitstream tools
With our logic gate organized, we need to translate out logic gate configuration to something our chip undertsands.
The protocols of talking to the FPGA are often called bitcode.
The format our Alchitry Cu undertands is special binary protocol documented in [project IceStorm](http://www.clifford.at/icestorm/).
For the Alchitry Au, I do not have documentation how how to work with the open source toolchain.

### Open Source for Alchitry Cu
[Icestorm](http://www.clifford.at/icestorm/) is a set of tools for generating and inspecting Lattice iCE40 bitstreams and flashing such devices.
We need this software to actually upload our program to our FPGA.
```
git clone https://github.com/cliffordwolf/icestorm.git icestorm
(
	cd icestorm
	make -j$(nproc)
	sudo make install
)
```

## Place and Route
Place and route tools take the description generated by a synthesis tool, and find a way to place it on a particular chip.
This step pays attention to a particular chips configuration, such as number and arrangment of logic cells, or placing tightly related cells close on the chip.

We have two options here, but really just use [nextpnr](https://github.com/YosysHQ/nextpnr), which is the current generation open-source toolchain.
### NextPNR (recommended)
The following script build NextPNR from the sources (sorry).
We disable the GUI, since not all platforms support it, in particular the raspberry pi.
```
# Build NextPNR, must disable GUI or crash.
git clone https://github.com/YosysHQ/nextpnr nextpnr
(
	cd nextpnr
	cmake -DARCH=ice40 -DBUILD_GUI=OFF .
	make -j$(nproc)
	sudo make install
)
```

### Arachne (not recommended)
This is the previous generation of nextpnr, which is only included for sake of completeness.
Unless you have a compelling reason (if you have to ask me, it's not compelling), don't use this.
```
git clone https://github.com/cseed/arachne-pnr.git arachne-pnr
(
	cd arachne-pnr
	make -j$(nproc)
	sudo make install
)
```
## Congratz! You've got it installed! Move on to the 01 module.


### (Extra) Open Source for Alchitry Au
Open source development for the AU is ongoing.
Check back in a bit.